Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor/src/Two_Level_Branch_Predictor_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor/src/Two_Level_Branch_Predictor_transition.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor/src/Two_Level_Branch_Predictor_transition.cpp	(revision 112)
@@ -90,16 +90,24 @@
             {
               log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * UPDATE [%d]",i);
+              log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * miss             : %d",PORT_READ(in_UPDATE_MISS [i]));
+              log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * update_on_predict: %d",_param->_update_on_prediction);
               
               // Update if 
               //  * update_on_prediction and miss
               //  * not update_on_prediction
-              if (not _param->_update_on_prediction or (_param->_update_on_prediction and PORT_READ(in_UPDATE_MISS [i])))
-                {
-                  Taddress_t address     = PORT_READ(in_UPDATE_ADDRESS   [i]);
-                  Thistory_t history     = PORT_READ(in_UPDATE_HISTORY   [i]);
-                  Tcontrol_t direction   = PORT_READ(in_UPDATE_DIRECTION [i])&1;
+              Tcontrol_t history_val = PORT_READ(in_UPDATE_HISTORY_VAL [i]);
+
+              if (not _param->_update_on_prediction or 
+                  (_param->_update_on_prediction and PORT_READ(in_UPDATE_MISS [i])) or
+                  not history_val // static_prediction
+                  )
+                {
+                  Taddress_t address     = PORT_READ(in_UPDATE_ADDRESS     [i]);
+                  Thistory_t history     = PORT_READ(in_UPDATE_HISTORY     [i]);
+                  Tcontrol_t direction   = PORT_READ(in_UPDATE_DIRECTION   [i])&1;
 
                   log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * address          : %.8x",address);
                   log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * direction        : %d",direction);
+                  log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * history_val      : %d",direction);
 
                   Thistory_t pht_bht_history = 0;
@@ -107,16 +115,20 @@
                   if (_param->_have_bht)
                     {
+                      log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * bht");
+
                       Thistory_t bht_history = (history>>_param->_bht_history_rshift)&_param->_bht_history_mask;
                       Thistory_t bht_num_reg = address & _param->_bht_address_mask;
                       
+                      log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"    * bht_history (old): %x",bht_history);
+                      log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"    * bht_num_reg      : %x",bht_num_reg);
+                      
+                      // BHT : shift register
+                      if (not history_val)
+                        bht_history = (direction)?_param->_bht_init_take:_param->_bht_init_ntake;
+                      else
+                        bht_history = ((bht_history<<1) | direction)&_param->_bht_history_mask ;
+                        
                       pht_bht_history = bht_history;
-                      
-                      log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * bht_history (old): %x",bht_history);
-                      log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * bht_num_reg      : %x",bht_num_reg);
-                      
-                      // BHT : shift register
-                      
-                      bht_history = ((bht_history<<1) | direction)&_param->_bht_history_mask ;
-                      log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * bht_history (new): %x",bht_history);
+                      log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"    * bht_history (new): %x",bht_history);
                       reg_BHT [bht_num_reg]               = bht_history;
                     }
@@ -124,17 +136,22 @@
                   if (_param->_have_pht)
                     {
+                      log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * pht");
+
                       Thistory_t pht_history = (history>>_param->_pht_history_rshift)&_param->_pht_history_mask;
                       Thistory_t pht_num_reg = pht_bht_history xor ((address&_param->_pht_address_share_mask)<<_param->_pht_address_share_lshift);
                       Thistory_t pht_num_bank= (address>>_param->_pht_address_bank_rshift)&_param->_pht_address_bank_mask;
                       
-                      log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * bht_history (old): %x",pht_bht_history);
-                      log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * pht_history (old): %x",pht_history);
-                      log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * pht_num_reg      : %x",pht_num_reg);
-                      log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * pht_num_bank     : %x",pht_num_bank);
+                      log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"    * bht_history (old): %x",pht_bht_history);
+                      log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"    * pht_history (old): %x",pht_history);
+                      log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"    * pht_num_reg      : %x",pht_num_reg);
+                      log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"    * pht_num_bank     : %x",pht_num_bank);
                       
                       // PHT : saturation counter
-                      pht_history = (direction==1)?((pht_history<_param->_pht_counter_max)?(pht_history+1):(pht_history)):((pht_history>0)?(pht_history-1):(pht_history));
-                      
-                      log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * pht_history (new): %x",pht_history);
+                      if (not history_val)
+                        pht_history = (direction)?_param->_pht_init_take:_param->_pht_init_ntake;
+                      else
+                        pht_history = (direction==1)?((pht_history<_param->_pht_counter_max)?(pht_history+1):(pht_history)):((pht_history>0)?(pht_history-1):(pht_history));
+                      
+                      log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"    * pht_history (new): %x",pht_history);
                       
                       reg_PHT [pht_num_bank][pht_num_reg] = pht_history;
@@ -145,5 +162,5 @@
 
 #if defined(DEBUG) and DEBUG_Two_Level_Branch_Predictor and (DEBUG >= DEBUG_TRACE)
-    if (0)
+    if (1)
     {
       log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  * Dump Two_Level_Branch_Predictor");
@@ -180,20 +197,27 @@
           for (uint32_t num_bank=0; num_bank <_param->_pht_nb_bank; ++num_bank)
             {
-              log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  [%.4d]",num_bank);
-
-              for (uint32_t i=0; i<_param->_pht_size_bank; i+=limit)
-                {
-                  std::string str = "";
+              if (_param->_pht_size_bank == 1)
+                {
+                  log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  [%.4d][0000] %4x",num_bank,reg_PHT[num_bank][0]);
+                }
+              else
+                {
+                  log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"  [%.4d]",num_bank);
                   
-                  for (uint32_t j=0; j<limit; j++)
+                  for (uint32_t i=0; i<_param->_pht_size_bank; i+=limit)
                     {
-                      uint32_t index = i+j;
-                      if (index >= _param->_pht_nb_counter)
-                        break;
-                      else
-                        str+=toString("[%.4d] %.4x ",index,reg_PHT[num_bank][index]);
+                      std::string str = "";
+                      
+                      for (uint32_t j=0; j<limit; j++)
+                        {
+                          uint32_t index = i+j;
+                          if (index >= _param->_pht_size_bank)
+                            break;
+                          else
+                            str+=toString("[%.4d] %.4x ",index,reg_PHT[num_bank][index]);
+                        }
+                      
+                      log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"    %s",str.c_str());
                     }
-                  
-                  log_printf(TRACE,Two_Level_Branch_Predictor,FUNCTION,"    %s",str.c_str());
                 }
             }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/include/Meta_Predictor.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/include/Meta_Predictor.h	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/include/Meta_Predictor.h	(revision 112)
@@ -80,4 +80,5 @@
   public    : SC_IN (Taddress_t)           **  in_UPDATE_ADDRESS       ;//[nb_inst_update]
   public    : SC_IN (Thistory_t)           **  in_UPDATE_HISTORY       ;//[nb_inst_update]
+  public    : SC_IN (Tcontrol_t)           **  in_UPDATE_HISTORY_VAL   ;//[nb_inst_update]
   public    : SC_IN (Tcontrol_t)           **  in_UPDATE_DIRECTION     ;//[nb_inst_update]
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_allocation.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_allocation.cpp	(revision 112)
@@ -58,5 +58,5 @@
     // ~~~~~[ Interface : "predict" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     {
-      ALLOC1_INTERFACE("predict",IN,WEST,_("Predict direction interface"),_param->_nb_inst_predict);
+      ALLOC1_INTERFACE_BEGIN("predict",IN,WEST,_("Predict direction interface"),_param->_nb_inst_predict);
 
       ALLOC1_VALACK_IN ( in_PREDICT_VAL          ,VAL);
@@ -65,9 +65,11 @@
       ALLOC1_SIGNAL_OUT(out_PREDICT_DIRECTION    ,"DIRECTION"    ,Tcontrol_t,1                    );
       ALLOC1_SIGNAL_OUT(out_PREDICT_HISTORY      ,"HISTORY"      ,Thistory_t,_param->_size_history);
+
+      ALLOC1_INTERFACE_END(_param->_nb_inst_predict);
     }
 
     // ~~~~~[ Interface : "update" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     {
-      ALLOC1_INTERFACE("update",IN,WEST,_("Update direction interface"),_param->_nb_inst_update);
+      ALLOC1_INTERFACE_BEGIN("update",IN,WEST,_("Update direction interface"),_param->_nb_inst_update);
 
       ALLOC1_VALACK_IN ( in_UPDATE_VAL           ,VAL);
@@ -75,5 +77,8 @@
       ALLOC1_SIGNAL_IN ( in_UPDATE_ADDRESS       ,"ADDRESS"      ,Taddress_t,_param->_size_address);
       ALLOC1_SIGNAL_IN ( in_UPDATE_HISTORY       ,"HISTORY"      ,Thistory_t,_param->_size_history);
+      ALLOC1_SIGNAL_IN ( in_UPDATE_HISTORY_VAL   ,"HISTORY_VAL"  ,Tcontrol_t,1                    );
       ALLOC1_SIGNAL_IN ( in_UPDATE_DIRECTION     ,"DIRECTION"    ,Tcontrol_t,1                    );
+
+      ALLOC1_INTERFACE_END(_param->_nb_inst_update);
     }
     
@@ -218,4 +223,6 @@
           COMPONENT_MAP(_component,src , "in_UPDATE_"                          +toString(j)+"_HISTORY"      ,
                                    dest,"out_UPDATE_PREDICTOR_"+toString(i)+"_"+toString(j)+"_HISTORY"      );
+          COMPONENT_MAP(_component,src , "in_UPDATE_"                          +toString(j)+"_HISTORY_VAL"  ,
+                                   dest,"out_UPDATE_PREDICTOR_"+toString(i)+"_"+toString(j)+"_HISTORY_VAL"  );
           if (_param->_predictor_update_on_prediction [i])
           COMPONENT_MAP(_component,src , "in_UPDATE_"                          +toString(j)+"_MISS"         ,
@@ -286,19 +293,22 @@
 #endif
 
-          PORT_MAP(_component,src , "in_UPDATE_"+toString(i)+"_VAL"      ,
-                              dest, "in_UPDATE_"+toString(i)+"_VAL"      );
-          PORT_MAP(_component,src ,"out_UPDATE_"+toString(i)+"_ACK"      ,
-                              dest,"out_UPDATE_"+toString(i)+"_ACK"      );
-          PORT_MAP(_component,src , "in_UPDATE_"+toString(i)+"_HISTORY"  ,
-                              dest, "in_UPDATE_"+toString(i)+"_HISTORY"  );
-          PORT_MAP(_component,src , "in_UPDATE_"+toString(i)+"_DIRECTION",
-                              dest, "in_UPDATE_"+toString(i)+"_DIRECTION");
-        }
-      
-      //  out_UPDATE_PREDICTOR_VAL       -> two_level_branch_predictor. in_UPDATE_PREDICTOR_VAL      
-      //   in_UPDATE_PREDICTOR_ACK       -> two_level_branch_predictor.out_UPDATE_PREDICTOR_ACK      
-      //  out_UPDATE_PREDICTOR_HISTORY   -> two_level_branch_predictor. in_UPDATE_PREDICTOR_HISTORY  
-      //  out_UPDATE_PREDICTOR_DIRECTION -> two_level_branch_predictor. in_UPDATE_PREDICTOR_DIRECTION
-      //  out_UPDATE_PREDICTOR_MISS      -> two_level_branch_predictor. in_UPDATE_PREDICTOR_MISS     
+          PORT_MAP(_component,src , "in_UPDATE_"+toString(i)+"_VAL"        ,
+                              dest, "in_UPDATE_"+toString(i)+"_VAL"        );
+          PORT_MAP(_component,src ,"out_UPDATE_"+toString(i)+"_ACK"        ,
+                              dest,"out_UPDATE_"+toString(i)+"_ACK"        );
+          PORT_MAP(_component,src , "in_UPDATE_"+toString(i)+"_HISTORY"    ,
+                              dest, "in_UPDATE_"+toString(i)+"_HISTORY"    );
+          PORT_MAP(_component,src , "in_UPDATE_"+toString(i)+"_HISTORY_VAL",
+                              dest, "in_UPDATE_"+toString(i)+"_HISTORY_VAL");
+          PORT_MAP(_component,src , "in_UPDATE_"+toString(i)+"_DIRECTION"  ,
+                              dest, "in_UPDATE_"+toString(i)+"_DIRECTION"  );
+        }
+      
+      //  out_UPDATE_PREDICTOR_VAL        -> two_level_branch_predictor. in_UPDATE_PREDICTOR_VAL      
+      //   in_UPDATE_PREDICTOR_ACK        -> two_level_branch_predictor.out_UPDATE_PREDICTOR_ACK      
+      //  out_UPDATE_PREDICTOR_HISTORY    -> two_level_branch_predictor. in_UPDATE_PREDICTOR_HISTORY  
+      //  out_UPDATE_PREDICTOR_HISTORY_VAL-> two_level_branch_predictor. in_UPDATE_PREDICTOR_HISTORY  
+      //  out_UPDATE_PREDICTOR_DIRECTION  -> two_level_branch_predictor. in_UPDATE_PREDICTOR_DIRECTION
+      //  out_UPDATE_PREDICTOR_MISS       -> two_level_branch_predictor. in_UPDATE_PREDICTOR_MISS     
 
     }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_deallocation.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_deallocation.cpp	(revision 112)
@@ -40,4 +40,5 @@
         DELETE1_SIGNAL( in_UPDATE_ADDRESS       ,_param->_nb_inst_update,_param->_size_address);
         DELETE1_SIGNAL( in_UPDATE_HISTORY       ,_param->_nb_inst_update,_param->_size_history);
+        DELETE1_SIGNAL( in_UPDATE_HISTORY_VAL   ,_param->_nb_inst_update,1                    );
         DELETE1_SIGNAL( in_UPDATE_DIRECTION     ,_param->_nb_inst_update,1                    );
       }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Parameters.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Parameters.cpp	(revision 112)
@@ -64,4 +64,8 @@
     if (_have_meta_predictor)
       _predictor_update_on_prediction [_nb_predictor-1] = false;
+
+//     // All predictor can't update on prediction ....
+//     for (uint32_t i=0; i<_nb_predictor; ++i)
+//       _predictor_update_on_prediction [i] = false;
 
     _param_two_level_branch_predictor = new morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::direction::meta_predictor::two_level_branch_predictor::Parameters * [_nb_predictor];
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/include/Direction.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/include/Direction.h	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/include/Direction.h	(revision 112)
@@ -63,18 +63,19 @@
 
     // ~~~~~[ Interface : "predict" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-  public    : SC_IN (Tcontrol_t)           **  in_PREDICT_VAL        ;
-  public    : SC_OUT(Tcontrol_t)           ** out_PREDICT_ACK        ;
-  public    : SC_IN (Taddress_t)           **  in_PREDICT_ADDRESS_SRC;
-  public    : SC_IN (Tcontrol_t)           **  in_PREDICT_STATIC     ;
-  public    : SC_IN (Tcontrol_t)           **  in_PREDICT_LAST_TAKE  ;
-  public    : SC_OUT(Thistory_t)           ** out_PREDICT_HISTORY    ;
-  public    : SC_OUT(Tcontrol_t)           ** out_PREDICT_DIRECTION  ;
+  public    : SC_IN (Tcontrol_t)           **  in_PREDICT_VAL             ;
+  public    : SC_OUT(Tcontrol_t)           ** out_PREDICT_ACK             ;
+  public    : SC_IN (Taddress_t)           **  in_PREDICT_ADDRESS_SRC     ;
+  public    : SC_IN (Tcontrol_t)           **  in_PREDICT_STATIC          ;
+  public    : SC_IN (Tcontrol_t)           **  in_PREDICT_LAST_TAKE       ;
+  public    : SC_OUT(Thistory_t)           ** out_PREDICT_HISTORY         ;
+  public    : SC_OUT(Tcontrol_t)           ** out_PREDICT_DIRECTION       ;
 
     // ~~~~~[ Interface : "update" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-  public    : SC_IN (Tcontrol_t)           **  in_UPDATE_VAL        ;
-  public    : SC_OUT(Tcontrol_t)           ** out_UPDATE_ACK        ;
-  public    : SC_IN (Taddress_t)           **  in_UPDATE_ADDRESS    ;
-  public    : SC_IN (Thistory_t)           **  in_UPDATE_HISTORY    ;
-  public    : SC_IN (Tcontrol_t)           **  in_UPDATE_DIRECTION  ;
+  public    : SC_IN (Tcontrol_t)           **  in_UPDATE_VAL              ;
+  public    : SC_OUT(Tcontrol_t)           ** out_UPDATE_ACK              ;
+  public    : SC_IN (Taddress_t)           **  in_UPDATE_ADDRESS          ;
+  public    : SC_IN (Thistory_t)           **  in_UPDATE_HISTORY          ;
+  public    : SC_IN (Tcontrol_t)           **  in_UPDATE_DIRECTION        ;
+  public    : SC_IN (Tcontrol_t)           **  in_UPDATE_PREDICTION_IFETCH;
 
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/src/Direction_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/src/Direction_allocation.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/src/Direction_allocation.cpp	(revision 112)
@@ -49,5 +49,5 @@
 							 ,IN
 							 ,SOUTH,
-							 "Generalist interface"
+							 _("Generalist interface")
 #endif
 							 );
@@ -59,5 +59,5 @@
     // ~~~~~[ Interface : "predict" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     {
-      ALLOC1_INTERFACE("predict", IN, SOUTH, "Interface predict",_param->_nb_inst_predict);
+      ALLOC1_INTERFACE_BEGIN("predict", IN, SOUTH, _("Interface predict"),_param->_nb_inst_predict);
 
       ALLOC1_VALACK_IN ( in_PREDICT_VAL        ,VAL);
@@ -68,15 +68,20 @@
       ALLOC1_SIGNAL_OUT(out_PREDICT_HISTORY    ,"history"    ,Thistory_t,_param->_size_history);
       ALLOC1_SIGNAL_OUT(out_PREDICT_DIRECTION  ,"direction"  ,Tcontrol_t,1);
+
+      ALLOC1_INTERFACE_END(_param->_nb_inst_predict);
     }
 
     // ~~~~~[ Interface : "update" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     {
-      ALLOC1_INTERFACE("update", IN, SOUTH, "Interface update",_param->_nb_inst_update);
-
-      ALLOC1_VALACK_IN ( in_UPDATE_VAL      ,VAL);
-      ALLOC1_VALACK_OUT(out_UPDATE_ACK      ,ACK);
-      ALLOC1_SIGNAL_IN ( in_UPDATE_ADDRESS  ,"address"  ,Taddress_t,_param->_size_instruction_address);
-      ALLOC1_SIGNAL_IN ( in_UPDATE_HISTORY  ,"history"  ,Thistory_t,_param->_size_history);
-      ALLOC1_SIGNAL_IN ( in_UPDATE_DIRECTION,"direction",Tcontrol_t,1);
+      ALLOC1_INTERFACE_BEGIN("update", IN, SOUTH, _("Interface update"),_param->_nb_inst_update);
+
+      ALLOC1_VALACK_IN ( in_UPDATE_VAL              ,VAL);
+      ALLOC1_VALACK_OUT(out_UPDATE_ACK              ,ACK);
+      ALLOC1_SIGNAL_IN ( in_UPDATE_ADDRESS          ,"address"          ,Taddress_t,_param->_size_instruction_address);
+      ALLOC1_SIGNAL_IN ( in_UPDATE_HISTORY          ,"history"          ,Thistory_t,_param->_size_history);
+      ALLOC1_SIGNAL_IN ( in_UPDATE_DIRECTION        ,"direction"        ,Tcontrol_t,1);
+      ALLOC1_SIGNAL_IN ( in_UPDATE_PREDICTION_IFETCH,"prediction_ifetch",Tcontrol_t,1);
+
+      ALLOC1_INTERFACE_END(_param->_nb_inst_update);
     }
 
@@ -183,4 +188,6 @@
           COMPONENT_MAP(_component,src , "in_UPDATE_"+toString(i)+          "_HISTORY"    ,
                                    dest,"out_UPDATE_"+toString(i)+"_PREDICTOR_HISTORY"    );
+          COMPONENT_MAP(_component,src , "in_UPDATE_"+toString(i)+          "_HISTORY_VAL"      ,
+                                   dest,"out_UPDATE_"+toString(i)+"_PREDICTOR_PREDICTION_IFETCH");
         }
     }
@@ -212,25 +219,25 @@
 #endif
 	  
-	  PORT_MAP(_component,src , "in_PREDICT_"+toString(i)+"_VAL"        ,
-		              dest, "in_PREDICT_"+toString(i)+"_VAL"        );
-	  PORT_MAP(_component,src ,"out_PREDICT_"+toString(i)+"_ACK"        ,
-		              dest,"out_PREDICT_"+toString(i)+"_ACK"        );
-	  PORT_MAP(_component,src , "in_PREDICT_"+toString(i)+"_ADDRESS_SRC",
-		              dest, "in_PREDICT_"+toString(i)+"_ADDRESS_SRC");
-	  PORT_MAP(_component,src , "in_PREDICT_"+toString(i)+"_STATIC"     ,
-		              dest, "in_PREDICT_"+toString(i)+"_STATIC"     );
-	  PORT_MAP(_component,src , "in_PREDICT_"+toString(i)+"_LAST_TAKE"  ,
-		              dest, "in_PREDICT_"+toString(i)+"_LAST_TAKE"  );
-	  if (_param->_have_port_history)
-	  PORT_MAP(_component,src ,"out_PREDICT_"+toString(i)+"_HISTORY"    ,
-		              dest,"out_PREDICT_"+toString(i)+"_HISTORY"    );
-	  PORT_MAP(_component,src ,"out_PREDICT_"+toString(i)+"_DIRECTION"  ,
-		              dest,"out_PREDICT_"+toString(i)+"_DIRECTION"  );
-
-// 	  PORT_MAP(_component,src ,"out_PREDICT_"+toString(i)+"_PREDICTOR_VAL"        ,dest,"out_PREDICT_"+toString(i)+"_PREDICTOR_VAL"        );
-// 	  PORT_MAP(_component,src , "in_PREDICT_"+toString(i)+"_PREDICTOR_ACK"        ,dest, "in_PREDICT_"+toString(i)+"_PREDICTOR_ACK"        );
-// 	  PORT_MAP(_component,src ,"out_PREDICT_"+toString(i)+"_PREDICTOR_ADDRESS_SRC",dest,"out_PREDICT_"+toString(i)+"_PREDICTOR_ADDRESS_SRC");
-// 	  PORT_MAP(_component,src , "in_PREDICT_"+toString(i)+"_PREDICTOR_HISTORY"    ,dest, "in_PREDICT_"+toString(i)+"_PREDICTOR_HISTORY"    );
-// 	  PORT_MAP(_component,src , "in_PREDICT_"+toString(i)+"_PREDICTOR_DIRECTION"  ,dest, "in_PREDICT_"+toString(i)+"_PREDICTOR_DIRECTION"  );
+	  PORT_MAP(_component,src , "in_PREDICT_"+toString(i)+"_VAL"              ,
+		              dest, "in_PREDICT_"+toString(i)+"_VAL"              );
+	  PORT_MAP(_component,src ,"out_PREDICT_"+toString(i)+"_ACK"              ,
+		              dest,"out_PREDICT_"+toString(i)+"_ACK"              );
+	  PORT_MAP(_component,src , "in_PREDICT_"+toString(i)+"_ADDRESS_SRC"      ,
+		              dest, "in_PREDICT_"+toString(i)+"_ADDRESS_SRC"      );
+	  PORT_MAP(_component,src , "in_PREDICT_"+toString(i)+"_STATIC"           ,
+		              dest, "in_PREDICT_"+toString(i)+"_STATIC"           );
+	  PORT_MAP(_component,src , "in_PREDICT_"+toString(i)+"_LAST_TAKE"        ,
+		              dest, "in_PREDICT_"+toString(i)+"_LAST_TAKE"        );
+	  if (_param->_have_port_history)                                         
+	  PORT_MAP(_component,src ,"out_PREDICT_"+toString(i)+"_HISTORY"          ,
+		              dest,"out_PREDICT_"+toString(i)+"_HISTORY"          );
+	  PORT_MAP(_component,src ,"out_PREDICT_"+toString(i)+"_DIRECTION"        ,
+		              dest,"out_PREDICT_"+toString(i)+"_DIRECTION"        );
+
+// 	  PORT_MAP(_component,src ,"out_PREDICT_"+toString(i)+"_PREDICTOR_VAL"              ,dest,"out_PREDICT_"+toString(i)+"_PREDICTOR_VAL"              );
+// 	  PORT_MAP(_component,src , "in_PREDICT_"+toString(i)+"_PREDICTOR_ACK"              ,dest, "in_PREDICT_"+toString(i)+"_PREDICTOR_ACK"              );
+// 	  PORT_MAP(_component,src ,"out_PREDICT_"+toString(i)+"_PREDICTOR_ADDRESS_SRC"      ,dest,"out_PREDICT_"+toString(i)+"_PREDICTOR_ADDRESS_SRC"      );
+// 	  PORT_MAP(_component,src , "in_PREDICT_"+toString(i)+"_PREDICTOR_HISTORY"          ,dest, "in_PREDICT_"+toString(i)+"_PREDICTOR_HISTORY"          );
+// 	  PORT_MAP(_component,src , "in_PREDICT_"+toString(i)+"_PREDICTOR_DIRECTION"        ,dest, "in_PREDICT_"+toString(i)+"_PREDICTOR_DIRECTION"        );
 	}
       
@@ -243,20 +250,25 @@
 #endif
 
-	  PORT_MAP(_component,src , "in_UPDATE_"+toString(i)+"_VAL"      ,
-		              dest, "in_UPDATE_"+toString(i)+"_VAL"      );
-	  PORT_MAP(_component,src ,"out_UPDATE_"+toString(i)+"_ACK"      ,
-		              dest,"out_UPDATE_"+toString(i)+"_ACK"      );
-	  PORT_MAP(_component,src , "in_UPDATE_"+toString(i)+"_ADDRESS"  ,
-		              dest, "in_UPDATE_"+toString(i)+"_ADDRESS"  );
+	  PORT_MAP(_component,src , "in_UPDATE_"+toString(i)+"_VAL"              ,
+		              dest, "in_UPDATE_"+toString(i)+"_VAL"              );
+	  PORT_MAP(_component,src ,"out_UPDATE_"+toString(i)+"_ACK"              ,
+		              dest,"out_UPDATE_"+toString(i)+"_ACK"              );
+	  PORT_MAP(_component,src , "in_UPDATE_"+toString(i)+"_ADDRESS"          ,
+		              dest, "in_UPDATE_"+toString(i)+"_ADDRESS"          );
 	  if (_param->_have_port_history)
-	  PORT_MAP(_component,src , "in_UPDATE_"+toString(i)+"_HISTORY"  ,
-		              dest, "in_UPDATE_"+toString(i)+"_HISTORY"  );
-	  PORT_MAP(_component,src , "in_UPDATE_"+toString(i)+"_DIRECTION",
-		              dest, "in_UPDATE_"+toString(i)+"_DIRECTION");
-// 	  PORT_MAP(_component,src ,"out_UPDATE_"+toString(i)+"_PREDICTOR_VAL"      ,dest,"out_UPDATE_"+toString(i)+"_PREDICTOR_VAL"      );
-// 	  PORT_MAP(_component,src , "in_UPDATE_"+toString(i)+"_PREDICTOR_ACK"      ,dest, "in_UPDATE_"+toString(i)+"_PREDICTOR_ACK"      );
-// 	  PORT_MAP(_component,src ,"out_UPDATE_"+toString(i)+"_PREDICTOR_ADDRESS"  ,dest,"out_UPDATE_"+toString(i)+"_PREDICTOR_ADDRESS"  );
-// 	  PORT_MAP(_component,src ,"out_UPDATE_"+toString(i)+"_PREDICTOR_HISTORY"  ,dest,"out_UPDATE_"+toString(i)+"_PREDICTOR_HISTORY"  );
-// 	  PORT_MAP(_component,src ,"out_UPDATE_"+toString(i)+"_PREDICTOR_DIRECTION",dest,"out_UPDATE_"+toString(i)+"_PREDICTOR_DIRECTION");
+	  PORT_MAP(_component,src , "in_UPDATE_"+toString(i)+"_HISTORY"          ,
+		              dest, "in_UPDATE_"+toString(i)+"_HISTORY"          );
+	  PORT_MAP(_component,src , "in_UPDATE_"+toString(i)+"_DIRECTION"        ,
+		              dest, "in_UPDATE_"+toString(i)+"_DIRECTION"        );
+	  PORT_MAP(_component,src , "in_UPDATE_"+toString(i)+"_PREDICTION_IFETCH",
+		              dest, "in_UPDATE_"+toString(i)+"_PREDICTION_IFETCH");
+
+// 	  PORT_MAP(_component,src ,"out_UPDATE_"+toString(i)+"_PREDICTOR_VAL"              ,dest,"out_UPDATE_"+toString(i)+"_PREDICTOR_VAL"              );
+// 	  PORT_MAP(_component,src , "in_UPDATE_"+toString(i)+"_PREDICTOR_ACK"              ,dest, "in_UPDATE_"+toString(i)+"_PREDICTOR_ACK"              );
+// 	  PORT_MAP(_component,src ,"out_UPDATE_"+toString(i)+"_PREDICTOR_ADDRESS"          ,dest,"out_UPDATE_"+toString(i)+"_PREDICTOR_ADDRESS"          );
+// 	  PORT_MAP(_component,src ,"out_UPDATE_"+toString(i)+"_PREDICTOR_HISTORY"          ,dest,"out_UPDATE_"+toString(i)+"_PREDICTOR_HISTORY"          );
+// 	  PORT_MAP(_component,src ,"out_UPDATE_"+toString(i)+"_PREDICTOR_DIRECTION"        ,dest,"out_UPDATE_"+toString(i)+"_PREDICTOR_DIRECTION"        );
+// 	  PORT_MAP(_component,src ,"out_UPDATE_"+toString(i)+"_PREDICTOR_PREDICTION_IFETCH",dest,"out_UPDATE_"+toString(i)+"_PREDICTOR_PREDICTION_IFETCH");
+
       }
     }
